opal/include/sys/atomic.h File Reference.TH "opal/include/sys/atomic.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/include/sys/atomic.h \- Atomic operations. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'include/sys/architecture.h'\fP
.br
\fC#include 'include/sys/atomic_impl.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBOPAL_SYS_ATOMIC_H\fP   1"
.br
.ti -1c
.RI "#define \fBOMPI_GCC_INLINE_ASSEMBLY\fP   OMPI_C_GCC_INLINE_ASSEMBLY"
.br
.ti -1c
.RI "#define \fBOMPI_DEC_INLINE_ASSEMBLY\fP   OMPI_C_DEC_INLINE_ASSEMBLY"
.br
.ti -1c
.RI "#define \fBOMPI_XLC_INLINE_ASSEMBLY\fP   OMPI_C_XLC_INLINE_ASSEMBLY"
.br
.ti -1c
.RI "#define \fBOPAL_HAVE_ATOMIC_SPINLOCKS\fP   (OPAL_HAVE_ATOMIC_CMPSET_32 || OPAL_HAVE_ATOMIC_CMPSET_64)"
.br
.ti -1c
.RI "#define \fBOPAL_NEED_INLINE_ATOMIC_SPINLOCKS\fP"
.br
.ti -1c
.RI "#define \fBOPAL_HAVE_ATOMIC_MATH_32\fP   OPAL_HAVE_ATOMIC_CMPSET_32"
.br
.ti -1c
.RI "#define \fBOPAL_HAVE_ATOMIC_MATH_64\fP   0"
.br
.ti -1c
.RI "#define \fBOPAL_HAVE_ATOMIC_MATH_64\fP   OPAL_HAVE_ATOMIC_CMPSET_64"
.br
.ti -1c
.RI "#define \fBopal_atomic_cmpset\fP(ADDR, OLDVAL, NEWVAL)"
.br
.RI "\fIAtomic compare and set of pointer with relaxed semantics. \fP"
.ti -1c
.RI "#define \fBopal_atomic_cmpset_acq\fP(ADDR, OLDVAL, NEWVAL)"
.br
.RI "\fIAtomic compare and set of pointer with acquire semantics. \fP"
.ti -1c
.RI "#define \fBopal_atomic_cmpset_rel\fP(ADDR, OLDVAL, NEWVAL)"
.br
.RI "\fIAtomic compare and set of pointer with release semantics. \fP"
.ti -1c
.RI "#define \fBopal_atomic_add\fP(ADDR, VALUE)"
.br
.RI "\fIAtomically increment the content depending on the type. \fP"
.ti -1c
.RI "#define \fBopal_atomic_sub\fP(ADDR, VALUE)"
.br
.RI "\fIAtomically decrement the content depending on the type. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBopal_atomic_lock_t\fP \fBopal_atomic_lock_t\fP"
.br
.in -1c
.SS "Enumerations"

.in +1c
.ti -1c
.RI "enum { \fBOPAL_ATOMIC_UNLOCKED\fP =  0, \fBOPAL_ATOMIC_LOCKED\fP =  1 }"
.br
.RI "\fIEnumeration of lock states. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "void \fBopal_atomic_mb\fP (void)"
.br
.RI "\fIMemory barrier. \fP"
.ti -1c
.RI "void \fBopal_atomic_rmb\fP (void)"
.br
.RI "\fIRead memory barrier. \fP"
.ti -1c
.RI "void \fBopal_atomic_wmb\fP (void)"
.br
.RI "\fIWrite memory barrier. \fP"
.ti -1c
.RI "static void \fBopal_atomic_init\fP (\fBopal_atomic_lock_t\fP *lock, int value)"
.br
.RI "\fIInitialize a lock to value. \fP"
.ti -1c
.RI "static int \fBopal_atomic_trylock\fP (\fBopal_atomic_lock_t\fP *lock)"
.br
.RI "\fITry to acquire a lock. \fP"
.ti -1c
.RI "static void \fBopal_atomic_lock\fP (\fBopal_atomic_lock_t\fP *lock)"
.br
.RI "\fIAcquire a lock by spinning. \fP"
.ti -1c
.RI "static void \fBopal_atomic_unlock\fP (\fBopal_atomic_lock_t\fP *lock)"
.br
.RI "\fIRelease a lock. \fP"
.ti -1c
.RI "int \fBopal_atomic_cmpset_32\fP (volatile int32_t *addr, int32_t oldval, int32_t newval)"
.br
.ti -1c
.RI "int \fBopal_atomic_cmpset_acq_32\fP (volatile int32_t *addr, int32_t oldval, int32_t newval)"
.br
.ti -1c
.RI "int \fBopal_atomic_cmpset_rel_32\fP (volatile int32_t *addr, int32_t oldval, int32_t newval)"
.br
.ti -1c
.RI "int \fBopal_atomic_cmpset_64\fP (volatile int64_t *addr, int64_t oldval, int64_t newval)"
.br
.ti -1c
.RI "int \fBopal_atomic_cmpset_acq_64\fP (volatile int64_t *addr, int64_t oldval, int64_t newval)"
.br
.ti -1c
.RI "int \fBopal_atomic_cmpset_rel_64\fP (volatile int64_t *addr, int64_t oldval, int64_t newval)"
.br
.ti -1c
.RI "static int32_t \fBopal_atomic_add_32\fP (volatile int32_t *addr, int delta)"
.br
.ti -1c
.RI "static int32_t \fBopal_atomic_sub_32\fP (volatile int32_t *addr, int delta)"
.br
.ti -1c
.RI "int64_t \fBopal_atomic_add_64\fP (volatile int64_t *addr, int64_t delta)"
.br
.ti -1c
.RI "int64_t \fBopal_atomic_sub_64\fP (volatile int64_t *addr, int64_t delta)"
.br
.ti -1c
.RI "static size_t \fBopal_atomic_add_size_t\fP (volatile size_t *addr, int delta)"
.br
.ti -1c
.RI "static size_t \fBopal_atomic_sub_size_t\fP (volatile size_t *addr, int delta)"
.br
.ti -1c
.RI "static int \fBopal_atomic_cmpset_xx\fP (volatile void *addr, int64_t oldval, int64_t newval, size_t length)"
.br
.ti -1c
.RI "static int \fBopal_atomic_cmpset_acq_xx\fP (volatile void *addr, int64_t oldval, int64_t newval, size_t length)"
.br
.ti -1c
.RI "static int \fBopal_atomic_cmpset_rel_xx\fP (volatile void *addr, int64_t oldval, int64_t newval, size_t length)"
.br
.ti -1c
.RI "static int \fBopal_atomic_cmpset_ptr\fP (volatile void *addr, void *oldval, void *newval)"
.br
.ti -1c
.RI "static int \fBopal_atomic_cmpset_acq_ptr\fP (volatile void *addr, void *oldval, void *newval)"
.br
.ti -1c
.RI "static int \fBopal_atomic_cmpset_rel_ptr\fP (volatile void *addr, void *oldval, void *newval)"
.br
.ti -1c
.RI "static void \fBopal_atomic_add_xx\fP (volatile void *addr, int32_t value, size_t length)"
.br
.ti -1c
.RI "static void \fBopal_atomic_sub_xx\fP (volatile void *addr, int32_t value, size_t length)"
.br
.ti -1c
.RI "static int \fBopal_atomic_add_pt\fP (volatile void *addr, void *delta)"
.br
.ti -1c
.RI "static int \fBopal_atomic_sub_ptr\fP (volatile void *addr, void *delta)"
.br
.in -1c
.SH "Detailed Description"
.PP 
Atomic operations. 

This API is patterned after the FreeBSD kernel atomic interface (which is influenced by Intel's ia64 architecture). The FreeBSD interface is documented at
.PP
http://www.freebsd.org/cgi/man.cgi?query=atomic&sektion=9
.PP
Only the necessary subset of functions are implemented here.
.PP
The following #defines will be true / false based on assembly support:
.PP
.IP "\(bu" 2
\fCOPAL_HAVE_ATOMIC_MEM_BARRIER\fP atomic memory barriers
.IP "\(bu" 2
\fCOPAL_HAVE_ATOMIC_SPINLOCKS\fP atomic spinlocks
.IP "\(bu" 2
\fCOPAL_HAVE_ATOMIC_MATH_32\fP if 32 bit add/sub/cmpset can be done 'atomicly'
.IP "\(bu" 2
\fCOPAL_HAVE_ATOMIC_MATH_64\fP if 32 bit add/sub/cmpset can be done 'atomicly'
.PP
.PP
Note that for the Atomic math, atomic add/sub may be implemented as C code using opal_atomic_cmpset. The appearance of atomic operation will be upheld in these cases.
.SH "Define Documentation"
.PP 
.SS "#define opal_atomic_add(ADDR, VALUE)"
.PP
\fBValue:\fP
.PP
.nf
opal_atomic_add_xx( (volatile void*)(ADDR), (int32_t)(VALUE), \
                       sizeof(*(ADDR)) )
.fi
Atomically increment the content depending on the type. 
.PP
This macro detect at compile time the type of the first argument and choose the correct function to be called.
.PP
\fBNote:\fP
.RS 4
This macro should only be used for integer types.
.RE
.PP
\fBParameters:\fP
.RS 4
\fIaddr\fP Address of <type> 
.br
\fIdelta\fP Value to add (converted to <type>). 
.RE
.PP

.SS "#define opal_atomic_cmpset(ADDR, OLDVAL, NEWVAL)"
.PP
\fBValue:\fP
.PP
.nf
opal_atomic_cmpset_xx( (volatile void*)(ADDR), (int64_t)(OLDVAL), \
                          (int64_t)(NEWVAL), sizeof(*(ADDR)) )
.fi
Atomic compare and set of pointer with relaxed semantics. 
.PP
This macro detect at compile time the type of the first argument and choose the correct function to be called.
.PP
\fBNote:\fP
.RS 4
This macro should only be used for integer types.
.RE
.PP
\fBParameters:\fP
.RS 4
\fIaddr\fP Address of <type>. 
.br
\fIoldval\fP Comparison value <type>. 
.br
\fInewval\fP New value to set if comparision is true <type>.
.RE
.PP
See opal_atomic_cmpset_* for pseudo-code. 
.SS "#define opal_atomic_cmpset_acq(ADDR, OLDVAL, NEWVAL)"
.PP
\fBValue:\fP
.PP
.nf
opal_atomic_cmpset_acq_xx( (volatile void*)(ADDR), (int64_t)(OLDVAL), \
                              (int64_t)(NEWVAL), sizeof(*(ADDR)) )
.fi
Atomic compare and set of pointer with acquire semantics. 
.PP
This macro detect at compile time the type of the first argument and choose the correct function to be called.
.PP
\fBNote:\fP
.RS 4
This macro should only be used for integer types.
.RE
.PP
\fBParameters:\fP
.RS 4
\fIaddr\fP Address of <type>. 
.br
\fIoldval\fP Comparison value <type>. 
.br
\fInewval\fP New value to set if comparision is true <type>.
.RE
.PP
See opal_atomic_cmpset_acq_* for pseudo-code. 
.SS "#define opal_atomic_cmpset_rel(ADDR, OLDVAL, NEWVAL)"
.PP
\fBValue:\fP
.PP
.nf
opal_atomic_cmpset_rel_xx( (volatile void*)(ADDR), (int64_t)(OLDVAL), \
                              (int64_t)(NEWVAL), sizeof(*(ADDR)) )
.fi
Atomic compare and set of pointer with release semantics. 
.PP
This macro detect at compile time the type of the first argument and choose the correct function to b
.PP
\fBNote:\fP
.RS 4
This macro should only be used for integer types.
.RE
.PP
\fBParameters:\fP
.RS 4
\fIaddr\fP Address of <type>. 
.br
\fIoldval\fP Comparison value <type>. 
.br
\fInewval\fP New value to set if comparision is true <type>.
.RE
.PP
See opal_atomic_cmpsetrel_* for pseudo-code. 
.SS "#define opal_atomic_sub(ADDR, VALUE)"
.PP
\fBValue:\fP
.PP
.nf
opal_atomic_sub_xx( (volatile void*)(ADDR), (int32_t)(VALUE),        \
                      sizeof(*(ADDR)) )
.fi
Atomically decrement the content depending on the type. 
.PP
This macro detect at compile time the type of the first argument and choose the correct function to be called.
.PP
\fBNote:\fP
.RS 4
This macro should only be used for integer types.
.RE
.PP
\fBParameters:\fP
.RS 4
\fIaddr\fP Address of <type> 
.br
\fIdelta\fP Value to substract (converted to <type>). 
.RE
.PP

.SH "Function Documentation"
.PP 
.SS "static void opal_atomic_init (\fBopal_atomic_lock_t\fP * lock, int value)\fC [inline, static]\fP"
.PP
Initialize a lock to value. 
.PP
\fBParameters:\fP
.RS 4
\fIlock\fP Address of the lock 
.br
\fIvalue\fP Initial value to set lock to 
.RE
.PP

.SS "static void opal_atomic_lock (\fBopal_atomic_lock_t\fP * lock)\fC [inline, static]\fP"
.PP
Acquire a lock by spinning. 
.PP
\fBParameters:\fP
.RS 4
\fIlock\fP Address of the lock. 
.RE
.PP

.SS "void opal_atomic_mb (void)"
.PP
Memory barrier. 
.PP
Will use system-specific features to instruct the processor and memory controller that all writes and reads that have been posted before the call to \fC\fBopal_atomic_mb()\fP\fP must appear to have completed before the next read or write.
.PP
\fBNote:\fP
.RS 4
This can have some expensive side effects, including flushing the pipeline, preventing the cpu from reordering instructions, and generally grinding the memory controller's performance. Use only if you need *both* read and write barriers. 
.RE
.PP

.SS "void opal_atomic_rmb (void)"
.PP
Read memory barrier. 
.PP
Use system-specific features to instruct the processor and memory conrtoller that all reads that have been posted before the call to \fC\fBopal_atomic_rmb()\fP\fP must appear to have been completed before the next read. Nothing is said about the ordering of writes when using \fC\fBopal_atomic_rmb()\fP\fP. 
.SS "static int opal_atomic_trylock (\fBopal_atomic_lock_t\fP * lock)\fC [inline, static]\fP"
.PP
Try to acquire a lock. 
.PP
\fBParameters:\fP
.RS 4
\fIlock\fP Address of the lock. 
.RE
.PP
\fBReturns:\fP
.RS 4
0 if the lock was acquired, 1 otherwise. 
.RE
.PP

.SS "static void opal_atomic_unlock (\fBopal_atomic_lock_t\fP * lock)\fC [inline, static]\fP"
.PP
Release a lock. 
.PP
\fBParameters:\fP
.RS 4
\fIlock\fP Address of the lock. 
.RE
.PP

.SS "void opal_atomic_wmb (void)"
.PP
Write memory barrier. 
.PP
Use system-specific features to instruct the processor and memory conrtoller that all writes that have been posted before the call to \fC\fBopal_atomic_wmb()\fP\fP must appear to have been completed before the next write. Nothing is said about the ordering of reads when using \fC\fBopal_atomic_wmb()\fP\fP. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
